#include <QtCore/QCoreApplication>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <curses.h>
#include <stdio.h>
#include <string.h>
#include <iostream>

using namespace std;

#define MIN(a, b) (((a) < (b)) ? (a) : (b))

const int size_of_map = 30;

typedef struct {
    int x,y;
} Position;

typedef int Map [size_of_map + 2][size_of_map + 2];

typedef struct {
    Position point [size_of_map * size_of_map];
    int cur_length;
} Point_Stream;

Point_Stream snake;

void build_clear_map (Map * map) {
    int t1;
    memset (map, 0, sizeof (*map));
    for (t1 = 0; t1 < size_of_map+1; t1++) {
        (*map)[t1][0] = -1;
        (*map)[t1][size_of_map] = -1;
        (*map)[0][t1] = -1;
        (*map)[size_of_map][t1] = -1;
    }
}

void add_snake (Map * map, Point_Stream * snake) {
    int t1;
    int length = snake->cur_length;
    for (t1 = 0; t1 < length; t1++) {
        (*map)[snake->point[t1].x][snake->point[t1].y] = -2;
    }
}


Position full_to;
Map * full_map;
Point_Stream * full_path;

void record_path (Point_Stream * path, Position from) {
    int l,l1,l2,l3,l4;
    path->cur_length ++;
    path->point[path->cur_length] = from;

    l1 = (*full_map)[from.x+1][from.y];
    l2 = (*full_map)[from.x-1][from.y];
    l3 = (*full_map)[from.x][from.y+1];
    l4 = (*full_map)[from.x][from.y-1];
    if (l1 < 0) { l1 = size_of_map + 3; };
    if (l2 < 0) { l2 = size_of_map + 3; };
    if (l3 < 0) { l3 = size_of_map + 3; };
    if (l4 < 0) { l4 = size_of_map + 3; };
    l = MIN (MIN(l1,l2),MIN(l3,l4));

    if (l == l1) {
        from.x ++;
        if (l != 1) {
           record_path (path, from);
        }
    } else
    if (l == l2) {
        from.x --;
        if (l != 1) {
           record_path (path, from);
        }
    } else
    if (l == l3) {
        from.y ++;
        if (l != 1) {
           record_path (path, from);
        }
    } else
    if (l == l4) {
        from.y --;
        if (l != 1) {
           record_path (path, from);
        }
    };
}


int full_find_path (Map * map, Point_Stream * path, Position * to) {
    full_map = map;
    full_path = path;
    full_to = *to;
    int t1,t2;
    (*full_map)[snake.point[0].x][snake.point[0].y] = 1;
    bool update = true;
    while (update) {
        update = false;
        for (t1 = 0; t1 < size_of_map ; t1++) {
            for (t2 = 0; t2 < size_of_map ; t2++) {
                if ((*full_map)[t1][t2] == 0) {
                    int l1,l2,l3,l4;
                    l1 = size_of_map + 10;
                    l2 = size_of_map + 10;
                    l3 = size_of_map + 10;
                    l4 = size_of_map + 10;
                    if (((*full_map)[t1+1][t2] > 0) && ((*full_map)[t1][t2]) < (*full_map)[t1+1][t2]) {
                        l1 = (*full_map)[t1+1][t2] + 1;
                    }
                    if (((*full_map)[t1-1][t2] > 0) && ((*full_map)[t1][t2]) < (*full_map)[t1-1][t2]) {
                        l2 = (*full_map)[t1-1][t2] + 1;
                    }
                    if (((*full_map)[t1][t2+1] > 0) && ((*full_map)[t1][t2]) < (*full_map)[t1][t2+1]) {
                        l3 = (*full_map)[t1][t2+1] + 1;
                    }
                    if (((*full_map)[t1][t2-1] > 0) && ((*full_map)[t1][t2]) < (*full_map)[t1][t2-1]) {
                        l4 = (*full_map)[t1][t2-1] + 1;
                    };
                    l1 = MIN (MIN(l1,l2),MIN(l3,l4));
                    if (l1 != size_of_map + 10) {
                        (*full_map)[t1][t2] = l1;
                        update = true;
                    }
                }
            }
        }
    };
    int l1,l2,l3,l4,l;
    l1 = (*full_map)[full_to.x+1][full_to.y];
    l2 = (*full_map)[full_to.x-1][full_to.y];
    l3 = (*full_map)[full_to.x][full_to.y+1];
    l4 = (*full_map)[full_to.x][full_to.y-1];
    if (l1 < 0) { l1 = size_of_map + 3; };
    if (l2 < 0) { l2 = size_of_map + 3; };
    if (l3 < 0) { l3 = size_of_map + 3; };
    if (l4 < 0) { l4 = size_of_map + 3; };
    l = MIN (MIN(l1,l2),MIN(l3,l4));
    if (l != size_of_map + 3) {
        path->point[0] = full_to;
        path->cur_length = 0;
        record_path (full_path, full_to);
        return l;
    } else {
        return -1;
    }
}

bool add_food (Map * map, Position * food) {
    bool good = false;
    bool good2 = false;
    int t1,t2;
    for (t1 = 0; t1 < size_of_map + 1; t1++) {
        for (t2 = 0; t2 < size_of_map + 1; t2++) {
            if (((*map)[t1][t2]) == 0) {
                good = true;
            }
        }
    };
    if (good) {
        while (!good2) {
            int x,y;
            x = rand () % (size_of_map + 1);
            y = rand () % (size_of_map + 1);
            good2 = (((*map)[x][y]) == 0);
            food->x = x;
            food->y = y;
        };
        return true;
    } else {
        return false;
    }
}

Point_Stream path;

const int  snake_length = 5;


void build_new_snake (int length) {
    snake.cur_length = length;
    int t;
    for (t = 0; t < length; t++) {
        snake.point[t].x = size_of_map/2;
        snake.point[t].y = size_of_map/2 + t;
    };
}

void step_path (Point_Stream * snake, Point_Stream * path, bool incriase) {
    int t;
    for (t = snake->cur_length; t > 0; t--) {
        snake->point[t] = snake->point[t-1];
    };
    if (incriase) {
        snake->cur_length++;
    };
    snake->point[0] = path->point[path->cur_length];
    path->cur_length--;
}

void Show (Point_Stream * snake, Position * food) {

    system("clear");
    Map map;
    build_clear_map(&map);
    add_snake (&map, snake);
    map[food->x][food->y]=-3;
    int t1,t2;
    for (t1 = 0; t1 < size_of_map + 2; t1++) {
        for (t2 = 0; t2 < size_of_map + 2; t2++) {
            if (map[t1][t2] == -1) {
                cout << "#";
            };
            if (map [t1][t2] == -2) {
                cout << "0";
            };
            if (map [t1][t2] == -3) {
                cout << "@";
            };
            if (map [t1][t2] == 0) {
                cout << " ";
            };
        }
        cout << endl;
    }

}

int main(int argc, char *argv[])
{
//    QCoreApplication a(argc, argv);
//    return a.exec();
    Map map;
    bool finish = false;
    Point_Stream path;
    Position food;
    bool can_work;
    int t3 = 0;
    int incriase = 0;

    //while (1)
    while (!finish) {
        build_new_snake (snake_length);
        {
            finish = false;
            build_clear_map (&map);
            add_snake (&map, &snake);
            can_work = true;

            can_work = add_food (&map, &food);

            while (can_work) {
                if (can_work) {
                    can_work = full_find_path (&map, &path, &food) != -1;
                    if (can_work) {
                        while (path.cur_length > 0) {
                           step_path (&snake,&path, incriase != 0);
                           if (incriase > 0) {
                               incriase--;
                           };
                           Show (&snake,&food);
                           sleep (1);
                        };
                        incriase = 2;
                        build_clear_map (&map);
                        add_snake (&map, &snake);
                        can_work = add_food (&map, &food);
                    }
                }
            };

            t3 ++;
            finish = t3 == 5;
        };
    }
}
